<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml"
                template="//layout/template.xhtml">
    <ui:define name="body">
        <h2>#{messages['net.ihe.gazelle.atna.SyslogCollector']}</h2>

        <h:form id="syslogForm">
            <ui:decorate template="/layout/panels/_panel.xhtml">
                <dl class="dl-horizontal">
                    <ui:include src="/syslog/_status.xhtml"/>
                </dl>
                <dl class="dl-horizontal">
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.IPHost']}</ui:define>
                        <h:outputText value="#{serverManager.getIps()}"/>
                    </ui:decorate>
                </dl>
                <dl class="dl-horizontal">
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.UDPPorts']}</ui:define>
                        <h:outputText value="#{syslogCollectorServer.getUDPPorts()}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.TCPPorts']}</ui:define>
                        <h:outputText value="#{syslogCollectorServer.getTCPPorts()}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.TLSPorts']}</ui:define>
                        <h:outputText value="#{syslogCollectorServer.getTLSPorts()}"/>
                    </ui:decorate>
                </dl>
            </ui:decorate>

        </h:form>
        <h:form id="browserform">

            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{syslogCollectorBrowser.filter.urlParameters}"/>
            <script>
                updateUrl("browserform:filterUrlParameters");
                jq162("#browserform\\:filterUrlParameters").bind('change',
                    function () {
                        updateUrl("browserform:filterUrlParameters");
                    });
            </script>
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>

            <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                <div class="form-horizontal">
                    <div class="row">
                        <div class="col-md-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{syslogCollectorBrowser.filter}"/>
                                <ui:param name="filterId" value="senderIP"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.atna.SenderIPHost']}"/>
                                <ui:param name="filterForm" value="browserform"/>
                            </ui:include>
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{syslogCollectorBrowser.filter}"/>
                                <ui:param name="filterId" value="transportType"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.atna.TransportType']}"/>
                                <ui:param name="filterForm" value="browserform"/>
                            </ui:include>
                        </div>
                        <div class="col-md-6">
                            <ui:include src="/filter/filterDate.xhtml">
                                <ui:param name="filter" value="#{syslogCollectorBrowser.filter}"/>
                                <ui:param name="filterId" value="timestamp"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.proxy.Timestamp']}"/>
                                <ui:param name="filterForm" value="browserform"/>
                            </ui:include>
                        </div>
                    </div>
                </div>
                <ui:define name="filter_buttons">
                    <a4j:commandLink title="#{messages['net.ihe.gazelle.proxy.Refresh']}"
                                     actionListener="#{syslogCollectorBrowser.refresh()}" render="browserform">
                        <span class="fa fa-refresh"></span>
                    </a4j:commandLink>
                    <a4j:commandLink title="#{messages['net.ihe.gazelle.atna.ResetCriteria']}"
                                     actionListener="#{syslogCollectorBrowser.reset()}" render="browserform">
                        <span class="fa fa-times-circle"></span>
                    </a4j:commandLink>
                </ui:define>
            </ui:decorate>

            #{dataTableStateHolder.setDescendingOn('arrivalTime')}
            <rich:dataTable id="syslogMessageTable" value="#{syslogCollectorBrowser.getSyslogMessages()}"
                            var="syslogEntry"
                            rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="syslogMessagesDS">
                <rich:column>
                    <f:facet name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.Id']}"/>
                    </f:facet>
                    <h:outputText value="#{syslogEntry.id}"/>
                </rich:column>
                <g:column sortBy="#{'arrivalTime'}" sortOrder="#{dataTableStateHolder.sortOrders['arrivalTime']}">
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.Timestamp']}"/>
                    </ui:define>
                    <h:outputText value="#{syslogCollectorBrowser.getSyslogMessageTimestamp(syslogEntry)}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.SenderIPHost']}"/>
                    </ui:define>
                    <h:outputText value="#{syslogEntry.senderIP}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.Transport']}"/>
                    </ui:define>
                    <h:outputText value="#{syslogEntry.transportType.getFriendlyName()}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.ValidationErrors']}"/>
                    </ui:define>
                    <h:outputText value="#{syslogEntry.errorMessage}"/>
                </g:column>
                <rich:column>
                    <f:facet name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.Actions']}"/>
                    </f:facet>
                    <h:outputLink value="#{syslogCollectorBrowser.getMessageViewLink(syslogEntry.id)}"
                                  title="#{messages['net.ihe.gazelle.atna.ViewMessage']}">
                        <span class="fa fa-search"></span>
                    </h:outputLink>
                </rich:column>

                <f:facet name="footer">
                    <ui:include src="/util/datatableFooter.xhtml">
                        <ui:param name="dataScrollerId" value="syslogMessagesDS"/>
                        <ui:param name="dataTableId" value="syslogMessageTable"/>
                    </ui:include>
                </f:facet>

            </rich:dataTable>

        </h:form>

    </ui:define>
</ui:composition>